/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//npm imports
const { Router } = require('express');

//local imports
const accountValidator = require("../../validators/accountValidator");
const loginController = require("../../controllers/api/account/loginController");
const logoutController = require("../../controllers/api/account/logoutController");
const registerController = require("../../controllers/api/account/registerController");
const migrationController = require("../../controllers/api/account/migrationController");
const updateController = require("../../controllers/api/account/updateController");
const rankEnumController = require("../../controllers/api/account/rankEnumController");
const passwordResetRequestController = require("../../controllers/api/account/passwordResetRequestController");
const passwordResetController = require("../../controllers/api/account/passwordResetController");
const emailChangeRequestController = require('../../controllers/api/account/emailChangeRequestController');
const deleteController = require("../../controllers/api/account/deleteController");

//globals
const router = Router();

//routing functions
//login
router.post('/login', accountValidator.user(), accountValidator.pass(), loginController.post);
//logout
router.post('/logout', logoutController.post);
//register
router.post('/register',
    accountValidator.user(),
    accountValidator.securePass(),
    accountValidator.pass('passConfirm'),
    accountValidator.email(), 
    registerController.post);

//migrate legacy profile
router.post('/migrate',
    accountValidator.user(),
    accountValidator.pass('oldPass'),
    accountValidator.securePass('newPass'),
    accountValidator.pass('passConfirm'),
    migrationController.post);

//update profile
router.post('/update',
    accountValidator.img(),
    accountValidator.bio(),
    accountValidator.signature(),
    accountValidator.pronouns(),
    accountValidator.pass('passChange.oldPass'),
    accountValidator.securePass('passChange.newPass'),
    accountValidator.pass('passChange.confirmPass'), 
    updateController.post);

//rankEnum
//This might seem silly, but it allows us to cleanly get the current rank list to compare against, without storing it in multiple places
router.get('/rankEnum', rankEnumController.get);
//password reset request
router.post('/passwordResetRequest', accountValidator.user(), passwordResetRequestController.post);
//password reset
router.post('/passwordReset', accountValidator.securityToken(), accountValidator.securePass(), accountValidator.pass('confirmPass'), passwordResetController.post);
//email change request
router.post('/emailChangeRequest', accountValidator.email(), accountValidator.pass(), emailChangeRequestController.post);
//account deletion
router.post('/delete', accountValidator.pass(), deleteController.post);

module.exports = router;